// Copyright 2016 the Go-FUSE Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

// Package test holds the tests for Go-FUSE and is not for end-user
// consumption.
package test

import (
	"reflect"
	"unsafe"
	"syscall"
)

/*
#include <sys/mman.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

int mmapFixed(int fd, void *addr, size_t length, int prot, int flags) {
	void *ok;
	ok = mmap(addr, length, prot, flags | MAP_FIXED, fd, 0);
	if (ok == MAP_FAILED) {
		return errno;
	}
	if (ok != addr) {
		fprintf(stderr, "mmap(fixed): ret != addr\n");
		abort();
	}
	return 0;
}
*/
import "C"

func mmapFixed(where []byte, fd int, prot int, flags int) error {
	bp := (*reflect.SliceHeader)(unsafe.Pointer(&where))
	errno := C.mmapFixed(C.int(fd), unsafe.Pointer(bp.Data), C.size_t(bp.Len), C.int(prot), C.int(flags))
	if errno != 0 {
		return syscall.Errno(errno)
	}
	return nil
}
